
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

// Khan.cpp : Defines the class behaviors for the application.
//

// 
// File not compatable with VLC version
//

#include "stdafx.h"
#include "Khan.h"

#include "MainFrm.h"
#include "Doc.h"
#include "DataView.h"
#include "SplitterView.h"

#include "shlobj.h"
#include "Shlwapi.h"
#include <commctrl.h>

// test dump - see Run() - v0.9.2.0
#include "Dump.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApp

BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
//	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen) out for view handling - ??
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApp construction

CApp::CApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_errCode = 0;
	m_retCode = 0;

}

/////////////////////////////////////////////////////////////////////////////
// The one and only CApp object

CApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CApp initialization

BOOL CApp::InitInstance()
{
	// Initialize OLE libraries.
	// MFC will call Coinitialize here and CoUninitialize on exit.
	if(!AfxOleInit())
	{ 
		AfxMessageBox(_T("ERROR Couldn't initialize COM"));
		return FALSE;
	}

	AfxEnableControlContainer();

	// Get current directory. Used by CDoc for file i/o.
	TCHAR szPath[1024];
	::GetCurrentDirectory(sizeof (szPath) / sizeof(TCHAR), szPath);
	m_curDirectory = szPath;

	// Set NULL
	m_pDoc				= NULL;		// Pointer to CDoc
//	m_pDataView			= NULL;		// Pointer to right pane CDataView
	m_hwndView			= NULL;		// Handle to CDataView
	m_hwndControlBar	= NULL;		// Handle to CControlBar
	m_hwndTreeDlg		= NULL;		// Handle to Tree Dlg
	m_hwndDownloadDlg	= NULL;		// Handle to Download Dlg
	m_hwndSearchDlg		= NULL;		// Handle to Search Dlg		10/04/2017 search
	m_hwndSplitter		= NULL;		// Handle to CSplitterView
	m_hwndTabView		= NULL;		// Handle to CTabView


	m_downloadDlgRect.SetRectEmpty();	// Rects set in CTabView::CreatePages()
	m_treeDlgRect.SetRectEmpty();
	m_updateDlgRect.SetRectEmpty();
	m_searchDlgRect.SetRectEmpty();		// 10/04/2017 search

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

//#ifdef _AFXDLL
//	Enable3dControls();			// Call this when using MFC in a shared DLL
//#else
//	Enable3dControlsStatic();	// Call this when linking to MFC statically
//#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	//
	// Sets key as:
	// HKEY_CURRENT_USER\Software\<company name>\<application name>\<section name>\<value name>.
	//
	// v 0.7.4
	// No SetReg and LoadStd.
//	SetRegistryKey(_T("Khan Desktop Application"));
//	LoadStdProfileSettings(0);  // No MRU - Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSplitterView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// v 0.7.4
	// Fix user using "Open With" dialog to run a video file.
	// Only run app with default file new.
	// Command line params are ignored.
	if(cmdInfo.m_nShellCommand != CCommandLineInfo::FileNew)
	{
		// m_nShellCommand will be FileOpen if file param passed in.
		// These will be ignored (see ProcessShellCommand())
		// CCommandLineInfo::FileOpen:
		// CCommandLineInfo::FilePrintTo:
		// CCommandLineInfo::FilePrint:
		// CCommandLineInfo::FileDDE
		// CCommandLineInfo::AppUnregister:
		// 
		return FALSE;
	}

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

// Get All Users App Data folder.
// 
// This is an attempt at Vista/win7 UAC non elevation.
CString CApp::GetAppDataFolder()
{


#if VS2005	
	// On 2003 server:
	//
	// CSIDL_LOCAL_APPDATA resolves to:
	//   C:\Documents and Settings\Administrator\Local Settings\Application Data
	//
	// CSIDL_COMMON_APPDATA resolves to:.
	//   C:\Documents and Settings\All Users\Application Data\KhanDesktop 
	//
	// Note: Not writable - permissions must be changed via msi to allow
	//
	// Note custom folder created in installer for CSIDL_COMMON_APPDATA
	CString path;
	TCHAR szPath[MAX_PATH];

	HRESULT result = SHGetFolderPath(NULL, CSIDL_COMMON_APPDATA, NULL, SHGFP_TYPE_DEFAULT, szPath);
	if(result != S_OK)
	{
		// Big problems.
		TRACE(_T("ERROR CApp GetAppDataFolder - failed\n"));
		AfxMessageBox(_T("Application was not installed properly."));
		path = m_curDirectory;
		return path;
	}
	path = szPath;
	path += _T("\\KhanDesktop");
	return path;

#else

	// For vs6.0, CSIDL_COMMON_APPDATA not supported.
	return m_curDirectory;

#endif


}

// Note #define _WIN32_IE 0x0400 in commctrl.h Version 1.2 vc6.0
// #define _WIN32_IE 0x0500 

//#define _WIN32_WINNT 0x0500
//#define _WIN32_IE 0x0500
//#include <commctrl.h>

//
// Get User App Data folder

BOOL CApp::GetUserSettingsFolder(CString & path)
{
	// My Documents folder - CSIDL_PERSONAL - note CSIDL_MYDOCUMENTS is virtual

#if VS2005
	// On 2003 server:
	// CSIDL_LOCAL_APPDATA resolves to:
	//   C:\Documents and Settings\Administrator\Local Settings\Application Data\KhanDesktop
	// CSIDL_APPDATA resolves to:
	//   C:\Documents and Settings\Administrator\Application Data\KhanDesktop
	//
	TCHAR szPath[MAX_PATH];
	CString sub = _T("KhanDesktop");
//	int csidl = CSIDL_APPDATA | CSIDL_FLAG_CREATE;			// roaming
	int csidl = CSIDL_LOCAL_APPDATA  | CSIDL_FLAG_CREATE;	// non roaming

	// Force folder creation - installer may fail to for user accounts.
	// Will need to fix as installer improves.
	HRESULT result = SHGetFolderPathAndSubDir(NULL,					// hWnd	
											  csidl,				// csidl
											  NULL,					// hToken
											  SHGFP_TYPE_CURRENT,	// dwFlags
											  sub,					// pszSubDir
											  szPath);
	if(result != S_OK)
	{
		// Big problems.
		TRACE(_T("ERROR CApp GetUserSettingsFolder - failed\n"));
		MessageBox(NULL, 
				   _T("Application was not installed properly."),
				   _T("Khan Desktop"),
				   MB_ICONEXCLAMATION);
		return FALSE;
	}
	// OK
	path = szPath;
	return TRUE;

#else

	// vc6 - use cur dir.
	if(m_curDirectory.IsEmpty())
		return FALSE;
	path = m_curDirectory;
	return TRUE;

#endif

}

/* orig
CString CApp::GetUserSettingsFolder()
{
	// vc6.0 and vs2003 on 2003 server:
	//	CSIDL_APPDATA : "C:\Documents and Settings\Administrator\Application Data\KhanDesktop"
	CString path;
	TCHAR szPath[MAX_PATH];

	if(!SHGetSpecialFolderPath(NULL, szPath, CSIDL_APPDATA, TRUE))
	{
		// Big problems.
		TRACE(_T("ERROR CApp GetUserSettingsFolder - failed\n"));
		AfxMessageBox(_T("Application was not installed properly."));
		path = m_curDirectory;
		return path;
	}
	path = szPath;
	path += _T("\\KhanDesktop");
	return path;
}

*/


// Synchronized thread access to a CString buffer.
//
// Note in vc6.0, we could wait for say 1000 ms.
// VS 2005 requires infinite, so this is rewritten
// here to bail if locked.
//
// Called from:
// CKhanDialog::OnStatusString().
BOOL CApp::GetThreadMessage(CString & str)
{
	CSingleLock singleLock(&m_critSection);

	// If available (not chancing waiting forever)
	if(!singleLock.IsLocked())
	{
		// vs2005 nust be INFINITE
		singleLock.Lock(INFINITE);				// Attempt to lock the shared resource
		if(singleLock.IsLocked())				// Resource now locked
		{
			str = m_strBuff;					// Use the shared resource...
			singleLock.Unlock();				// Unlock the resource for others.
			return TRUE;
		}
	}
	return FALSE;
}
// Synchronized thread access to a CString buffer.
//
// Called from:
// CKnanInet::ShowStatus().
void CApp::SetThreadMessage(const CString & str)
{
	CSingleLock singleLock(&m_critSection);

	// If available (not chancing waiting forever).
	if(!singleLock.IsLocked())
	{
		// vs2005 nust be INFINITE
		singleLock.Lock(INFINITE);				// Attempt to lock the shared resource
		if(singleLock.IsLocked())				// Resource has been locked
		{
			m_strBuff = str;					// Use the shared resource...
			singleLock.Unlock();				// Unlock the resource for others.
		}
	}
	// Else leave string as is.
}

// 12/13/14
// Overloaded called from:
// ...
BOOL CApp::GetThreadMessage(CString & errMsg, DWORD & errCode, int & retCode)
{
	CSingleLock singleLock(&m_critSection);

	// If available (not chancing waiting forever)
	if(!singleLock.IsLocked())
	{
		// vs2005 nust be INFINITE
		singleLock.Lock(INFINITE);				// Attempt to lock the shared resource
		if(singleLock.IsLocked())				// Resource now locked
		{
			errMsg = m_errMsg;					// Use the shared resources...
			errCode = m_errCode;
			retCode = m_retCode;

			singleLock.Unlock();				// Unlock the resource for others.
			return TRUE;
		}
	}
	return FALSE;
}
// 12/13/14
// Overloaded Called from:
//  ....
void CApp::SetThreadMessage(const CString & errMsg, const DWORD & errCode, const int & retCode)
{
	CSingleLock singleLock(&m_critSection);

	// If available (not chancing waiting forever).
	if(!singleLock.IsLocked())
	{
		// vs2005 nust be INFINITE
		singleLock.Lock(INFINITE);				// Attempt to lock the shared resource
		if(singleLock.IsLocked())				// Resource has been locked
		{
			m_errMsg = errMsg;					// Use the shared resources...
			m_errCode = errCode;
			m_retCode = retCode;
			singleLock.Unlock();				// Unlock the resource for others.
		}
	}
	// Else leave string as is.
}

int CApp::Run() 
{
	//dbg - no dump code
//	return CWinApp::Run();
	
	// test
	LoadDbgDll();
	
	// Default if debugging.
	#ifdef _DEBUG
	return CWinApp::Run();
	#endif

	// Prepare release dump handling. See dump.h.
	//
	// Get version.
	CString version;
	if(m_pDoc)
	{
		m_pDoc->GetVersion(version);
		version.Remove(_T('.'));		// lose decimals 0.9.1.0
	}

	// Add version to file name.
	CString name;
	if(!version.IsEmpty())
	{
		name.Format(_T("\\khan%s.dmp"), version);
	}
	else
		name = _T("\\khan.dmp");

	// Get folder.
	CString path;
	if(GetUserSettingsFolder(path))
	{
		path += name;
	}
	// Else use a temp folder.
	else
	{
		WCHAR szPath[MAX_PATH];
		GetTempPath(MAX_PATH, szPath );
		path = szPath;
		path.TrimRight(_T('\\'));// Lose backslash added by GetTempPath()
		path += name;	
	}

	// Set global exception filter and handlers in Dump.cpp.
	SetKhanExceptionFilter(path);

	// Default call.
	return CWinApp::Run();
}

// Catch unhandled framework exceptions.
LRESULT CApp::ProcessWndProcException(CException* e, const MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class

	/* Create minidump for any and all. See Dump.cpp.
	THROW_LAST();
	return 0;*/

	// Create minidump for any and all with msg. See Dump.cpp.
	//
	// From : http://msgroups.net/microsoft.public.vc.mfc/how-to-get-crash-dump-when-a-unhandle/41893
	TCHAR buf[1024] = {0};
	CString className = _T("No Class Name");
	CString errMsg = _T("No Error Message");
	if(e) 
	{
		if(e->GetErrorMessage(buf, 1024))
			errMsg = buf;
		CRuntimeClass* pClass = e->GetRuntimeClass();
		if(pClass && pClass->m_lpszClassName)
			className = pClass->m_lpszClassName;
	}
	CString msg;
	msg.Format(_T("Khan Unhandled MFC Exception - %s: %s"), className, errMsg);
	AfxMessageBox(msg);	
	THROW_LAST();
	return 0;
	

	/* Create minidump for a CInvalidArgException. See Dump.cpp.
	//
	// From : http://msgroups.net/microsoft.public.vc.mfc/how-to-get-crash-dump-when-a-unhandle/41893
	TCHAR buf[1024] = {0};
	CString className;
	if(e) 
	{
		e->GetErrorMessage(buf, 1024);
		CRuntimeClass* pClass = e->GetRuntimeClass();
		if(pClass && pClass->m_lpszClassName)
			className = pClass->m_lpszClassName;
	}
	if(className == _T("CInvalidArgException"))
	{
		CString msg;
		msg.Format(_T("Khan Unhandled MFC Exception - %s: %s"), className, buf);
		AfxMessageBox(msg);	
		THROW_LAST();
		return 0;
	}*/

	// Default handling.	
	return CWinApp::ProcessWndProcException(e, pMsg);
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_editAbout;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_editAbout = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_EDIT_ABOUT, m_editAbout);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CApp message handlers


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText(_T("About Khan Desktop"));
	CString version;
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(pDoc)
		pDoc->GetVersion(version);

	// 10/05/14
	// If hosed at TUX (defined in StdAfx.h).
	if(TUX_HOST)
	{
		m_editAbout.Format(	_T("Khan Desktop version:  %s\r\n\r\n")
							_T("This program is free software, developed\r\n")
							_T("independently from the Khan Academy.\r\n\r\n")
							_T("Get the latest version at:\r\n  www.khandesktop.tuxfamily.org\r\n\r\n")
							_T("Thank you Khan Academy:\r\n  www.khanacademy.org\r\n\r\n")
							_T("Thank you LAV Filters:\r\n  www.github.com/Nevcairiel/LAVFilters"),
								version);
	}
	else // SF 
	{
		m_editAbout.Format(	_T("Khan Desktop version:  %s\r\n\r\n")
							_T("This program is free software, developed\r\n")
							_T("independently from the Khan Academy.\r\n\r\n")
							_T("Get the latest version at:\r\n  www.sourceforge.net/projects/khandesktop/\r\n\r\n")
							_T("Thank you Khan Academy:\r\n  www.khanacademy.org\r\n\r\n")
							_T("Thank you Videolan VLC Media Player:\r\n  www.videolan.org"),
								version);
	}


	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


