

/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

#if !defined(AFX_TREEDIALOG_H__2F360897_1B16_4CA1_A8E1_7E08ED1323DF__INCLUDED_)
#define AFX_TREEDIALOG_H__2F360897_1B16_4CA1_A8E1_7E08ED1323DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// TreeDialog.h : header file
//

#include "KhanTreeCtrl.h"


/////////////////////////////////////////////////////////////////////////////
// CTreeDialog dialog

#define DUMMY_ITEM _T("dummy")
#define EMPTY_TOPIC _T("Empty Topic.")
#define VID_POSTFIX_LEN 2
#define VID_POSTFIX		_T("  ")  // marks item as a video 


///////////////////////////////////////////////////////////
// CTreeDialog
class CTreeDialog : public CDialog
{

// Construction
public:
	CTreeDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CTreeDialog)
	enum { IDD = IDD_DIALOG_TREE };
	CKhanTreeCtrl	m_treeCtrl;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTreeDialog)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTreeDialog)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnItemexpandingKhanTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangedKhanTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchanging(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetupTreeFont();
	//}}AFX_MSG
	afx_msg void OnTvnGetInfoTip(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg LRESULT OnUpdateTree(WPARAM wParam, LPARAM lParam);			// WM_USER_DLG_UPDATE
	afx_msg LRESULT OnUpdateVideoMarks(WPARAM wParam, LPARAM lParam);	// WM_USER_TREE_VID_UPDATE
	afx_msg LRESULT OnSetSelLastViewed(WPARAM wParam, LPARAM lParam);	// WM_USER_TREE_SET_SEL
	// 10/04/2017 search
	afx_msg LRESULT OnSetSelSearch(WPARAM wParam, LPARAM lParam);		// WM_USER_TREE_SET_SEARCH
	// 10/04/2017 developer utility
	afx_msg LRESULT OnDeleteSel(WPARAM wParam, LPARAM lParam);			// WM_USER_TREE_DELETE_SEL

	DECLARE_MESSAGE_MAP() 

private:
	BOOL	GetPathFromItemOld(HTREEITEM hItem, CStringArray & nodes);
	BOOL	GetPathNodesFromItem(HTREEITEM hItem, CNodeArray & nodeAr);
	void	DeleteAllChildren(HTREEITEM hItem);
	BOOL	SetCurrentSelection(HTREEITEM hSelItem);

	// Video prefix (mark) drawing / updating.
	BOOL	UpdateVideoMarksChild(HTREEITEM hItem);
	BOOL	SetVideoMarks(HTREEITEM hItem);
	void	DrawVideoMarks(HTREEITEM hItem, CDC * pDC);

	// Manual expand
	BOOL	ExpandChildTopic(CTopic & parentTopic, CVideo & curVideo,  
							 CStringArray & pathAr, HTREEITEM hParentItem,
							 int parentPathArIndex);
	// 10/04/2017 search
	BOOL	ExpandChildTopicSearch(CTopic & parentTopic, HTREEITEM hParentItem, 
								   const CStringArray & nodeAr, const int & nodeVideoIndex,
								   int iNodeArParent);
	BOOL m_manualExpand;

private:

	// Tree Font
	CFont m_treeFont;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TREEDIALOG_H__2F360897_1B16_4CA1_A8E1_7E08ED1323DF__INCLUDED_)
